<?xml version="1.0" encoding="ISO-8859-1" ?>

<!--
# $Id: extract_revisions.xsl,v 1.6 2004/01/08 09:30:00 camille Exp $

# Copyright 2001 MandrakeSoft S.A., tous droits rservs

#- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Project         : Mandrake Linux
# Module          : Borges
# File            : extract_revisions.xsl
# Author          : Camille Bgnis
# Created On      : Tue October 16 16:25:21 2001
# Copyright       : Camille Bgnis camille@mandrakesoft.com,
#                    MandrakeSoft under the GPL license
#- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

This stylesheet takes as input the output from diff2html,
extracts the desynchronized elements from respective source files
and outputs them to two different files for further processing by 
diff2html
-->

<!DOCTYPE xsl:stylesheet [
<!ENTITY quot '"'>
]>

<xsl:stylesheet
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  version="1.1"> 

<xsl:output method="xml" encoding="ISO-8859-1" indent="yes"/>

<xsl:param name="file1"/>
<xsl:param name="file2"/>
<xsl:param name="path"/>

<xsl:template match="/">
  
  <!-- get source file names -->
  
  <xsl:variable name="source1">
    <xsl:value-of select="$path"/><xsl:value-of select="substring-before(substring-after(//td[@class='modified'][1]/text(),'file=&quot;'),'&quot;')"/>
  </xsl:variable>
  <xsl:variable name="source2">
    <xsl:value-of select="$path"/><xsl:value-of select="substring-before(substring-after(//td[@class='modified'][2]/text(),'file=&quot;'),'&quot;')"/>
  </xsl:variable>
  
  <xsl:variable name="ids" select="//td[not((position()+1) mod 2)][contains(text(),'element')]"/>

      <!--
    <xsl:for-each select="//td[not((position()+1) mod 2)][contains(text(),'element')]">
   
      <xsl:variable name="id1">
        <xsl:value-of select="substring-before(substring-after(text(),'id=&quot;'),'&quot;')"/>
      </xsl:variable>
      <xsl:variable name="id2">
        <xsl:value-of select="substring-before(substring-after(following-sibling::td/text(),'id=&quot;'),'&quot;')"/>
      </xsl:variable>
      
      <xsl:message>
        id1: <xsl:value-of select="$id1"/>
        id2: <xsl:value-of select="$id2"/>
      </xsl:message>
      
      <xsl:if test="$id1=$id2">
        <id>
          <xsl:value-of select="$id1"/>
        </id>
      </xsl:if>

    </xsl:for-each>
  </xsl:variable>
-->
  
<!--
  <xsl:message>
    source1: <xsl:value-of select="$source1"/>
    source2: <xsl:value-of select="$source2"/>
        ids: <xsl:copy-of select="$ids"/>
  </xsl:message>
-->

  <xsl:document href="{$file1}">
    <xsl:call-template name="extract">
      <xsl:with-param name="ids">
        <xsl:copy-of select="$ids"/>
      </xsl:with-param>
      <xsl:with-param name="in"><xsl:value-of select="$source1"/>a</xsl:with-param>
    </xsl:call-template>
  </xsl:document>
  
  <xsl:document href="{$file2}">
    <xsl:call-template name="extract">
      <xsl:with-param name="ids">
        <xsl:copy-of select="$ids"/>
      </xsl:with-param>
      <xsl:with-param name="in"><xsl:value-of select="$source2"/>a</xsl:with-param>
    </xsl:call-template>
  </xsl:document>

</xsl:template>


<xsl:template name="extract">
  <xsl:param name="ids"/>
  <xsl:param name="in"/>
  <elements>
    <xsl:text>
      ***************************************************
</xsl:text>
    <xsl:for-each select="//td[not((position()+1) mod 2)][contains(text(),'element')]">
        <xsl:variable name="id" select="substring-before(substring-after(text(),'id=&quot;'),'&quot;')"/>
      <xsl:copy-of select="document($in,.)//*[@id=$id]"/>
      ***************************************************
    </xsl:for-each>
  </elements>
</xsl:template>

</xsl:stylesheet>
