<?xml version="1.0" encoding="ISO-8859-1" ?>

<!--
# $Id: filter.xsl,v 1.6 2005/07/11 09:28:29 camille Exp $

# Copyright 2001 MandrakeSoft S.A., tous droits rservs

#- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Project         : Mandrake Linux
# Module          : Borges
# File            : filter.xsl
# Author          : Camille Bgnis
# Created On      : Thu May 23 2002
# Copyright       : Camille Bgnis camille@mandrakesoft.com,
#                    MandrakeSoft under the GPL license
#- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

This stylesheet simply copies the input to the output, but filtering
out elements which "condition" attribute contains one of the words of
the "exclude" parameter.

 -->

<xsl:stylesheet
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  version="1.1"> 

<xsl:output method="xml" encoding="UTF-8" indent="no"/>

<xsl:param name="exclude"/>
<xsl:param name="OutputID"/>


<!-- If I provide an OutputID param on command line I only output that element -->
<xsl:template match="/">
  <xsl:choose>
    <xsl:when test="not($OutputID = '')">
      <xsl:apply-templates select="//*[@id=$OutputID]"/>
    </xsl:when>
    <xsl:otherwise>
      <xsl:copy>
        <xsl:apply-templates select="@*|node()"/>
      </xsl:copy>
    </xsl:otherwise>
  </xsl:choose>
</xsl:template>

<!-- filter out unwanted elements -->
<xsl:template match="*[@condition][contains($exclude,@condition)]">
</xsl:template>


<!-- Just copy everything else -->
<xsl:template match="@*|node()">
  <xsl:copy>
    <xsl:apply-templates select="@*|node()"/>
  </xsl:copy>
</xsl:template>

<!-- Discard comments though -->
<xsl:template match="comment()">
</xsl:template>


</xsl:stylesheet>
