#! /usr/bin/perl -w
#---------------------------------------------------------------
# Project         : Linux-Mandrake
# Module          : bin
# File            : confparse.pl
# Author          : Camille Bgnis
# Created On      : Mon Jun 26 2001
# Copyright       : Camille Bgnis <camille@mandrakesoft.com>,
#                    MandrakeSoft under the GPL license
#---------------------------------------------------------------
# synopsis: confparse.pl <XPath> <conf_file.xml>
# This script axtracts the value of the text node(s) of the element 
# passed as first argument from the XML file passed as second argument.


use XML::LibXML;

my $xpath = shift || die "$0: What's the element to extract?!\n";
my $file = shift || die "$0: What's the file to extract info from?!\n";

if ( $ENV{DEBUG} && $ENV{DEBUG} eq "yes" ) {
    print STDERR "Extracting $xpath from $file\n";
}


# print "$xpath\n";
# print "$file\n";
my $parser=XML::LibXML->new();
$parser->expand_entities(0);
$parser->load_ext_dtd(1);
$parser->recover(1);

my $conf=$parser->parse_file($file);

my @result=$conf->findnodes($xpath);

my $var="";

for my $elt (@result) { 
    my $string="";
    if ( $elt->firstChild ) {
	$string=$elt->textContent();
	$var.="$string " if ( $string );
    }
};
chop($var);
print $var;
