#! /usr/bin/perl -w
#---------------------------------------------------------------
# Project         : Linux-Mandrake
# Module          : bin
# File            : extract_doctype.pl
# Author          : Camille Bgnis
# Created On      : 2002-05-23
# Copyright       : Camille Bgnis <camille@mandrakesoft.com>,
#                    MandrakeSoft under the GPL license
#---------------------------------------------------------------
# This script extracts the DocType of the XML document given on input
#---------------------------------------------------------------

 

use XML::Twig;

my $usage="
Usage:
extract_doctype.pl <source XML file>

";
 
my $filename= $ARGV[0] || die $usage;
my $target= $ARGV[1];
my $doctype=""; 

open(FILE, "< $filename") || die "unknown file: \"$filename\" $!\n";  
while(<FILE>){ $doctype.=$_; };
close (FILE);

# regex is different whether there are entities or not
if ( $doctype=~ /<!DOCTYPE [^\]]*\]\s*>/ ) {
# entities
    $doctype=~s/.*?(<!DOCTYPE [^\]]*\]\s*>).*/$1/sg;
} else {
# no entities
    $doctype=~s/.*?(<!DOCTYPE [^\>]*>).*/$1/sg;
}
# remove possible entities ?

# $doctype=~s/\[.*/>/sg;

# If target defined replace doctype and revhistory in it 
if ( $target ) {
    my $output="";
open(FILE, "< $target") || die "unknown file: \"$target\" $!\n";  
while (<FILE>) { $output.=$_; };
close (FILE);
# regex is different whether there is entities or not
if ( $output=~ /<!DOCTYPE [^\]]*\]\s*>/ ) {
# entities
    $output=~s/<!DOCTYPE [^\]]*\]\s*>/$doctype/sg;
} else {
# no entities
    $output=~s/<!DOCTYPE [^\>]*>/$doctype/sg;
}

open(FILE, "> $target") || die "unknown file: \"$target\" $!\n";  
print FILE $output;
close (FILE);

} else { print $doctype; }
