#! /usr/bin/perl -w
#---------------------------------------------------------------
# Project         : Linux-Mandrake
# Module          : bin
# File            : get_DB_mod_deps.pl
# Author          : Camille Bgnis
# Created On      : Fri Nov 08 2002
# Copyright       : Camille Bgnis <camille@mandrakesoft.com>,
#                    MandrakeSoft under the GPL license
#---------------------------------------------------------------
# synopsis: get_DB_deps manual_name
# This script extracts from a source master file all required modules
# in language "xx".
# Output the results as a list of absolute file names onto STDOUT.


use XML::LibXML;

my $manual = $ARGV[0] || die "$0: What's the manual name?!\n";

my $top= $ARGV[1] || "master.top.xml";

# Put in this file index needed
my $indexfile=$manual.".index.dependencies";
open(INDEX, "> $indexfile") || die "Write error: \"$indexfile\" $!\n";  

# parse the master.top.xml to extract modules from it
my $parser=XML::LibXML->new();
$parser->expand_entities(0);
$parser->load_ext_dtd(1);

my $tree = $parser->parse_file($top);
my $root = $tree->getDocumentElement;

# get all modules IDs
my @allmodules=$root->findnodes('//*[@role="module"]');
foreach (sort @allmodules) {
    my $id=$_->getAttribute('id');
    print $id.".xml\n";
}

# get all index IDs
my @allindices=$root->findnodes('//index');
foreach (sort @allmodules) {
    print INDEX $manual.".index.xml\n";
}


close(INDEX);
