#! /usr/bin/perl -w
#---------------------------------------------------------------
# Project         : Linux-Mandrake
# Module          : bin
# File            : translation_template.pl
# Author          : Camille Bgnis
# Created On      : 2003-05-21
# Copyright       : Camille Bgnis <camille@mandrakesoft.com>,
#                    MandrakeSoft under the GPL license
#---------------------------------------------------------------
# synopsis: translation_template.pl <original_lang> <module.xml> 

# This script copies the original module template into a translation
# template if the module has not been transled yet


use XML::Twig;

my $original_lang = shift || die "$0: What's the original module language?!\n";
my $module = shift || die "$0: What's the module to translate?!\n";
# current language
my $lang=`pwd`;
$lang=~ s,.*/,,;
chop $lang;

#print "$lang\n";

# The template's root gi
my $root="";
my $content="";

# parse the original module to extract content from
my $twig= new XML::Twig(
			pretty_print => 'indented',
			comments => 'keep',
			TwigHandlers =>
			{ '*[@role="template"]' => \&module, }
			);
$twig->parsefile($module."a");

if( $root ne "" ) {
# get original's content
    open(FILE, "< ../$original_lang/$module") || die "Open error: \"../$original_lang/$module\" $!\n";
    my $isoriginal=0;
    my $original="";
    while(<FILE>) {
	if( /<$root/ ) {
	    s/lang=\"[^\"]+\"/lang=\"$lang\"/;
#	    print;
	}
	$original.=$_;
    }
    close(FILE);
    $original=~ s/.*?(<$root.*<\/$root>).*/$1/s;

# get module's content
    open(FILE, "< $module") || die "Open error: \"$module\" $!\n";
    my $template =0;
    while(<FILE>) {
	$content.=$_;
    }
    close(FILE);

    $content=~ s/(.*)<$root.*<\/$root>(.*)/$1$original$2/s;

    open(FILE, "> $module") || die "Open error: \"$module\" $!\n";
    print FILE $content;
    close(FILE);
}

sub module {
    my ($top, $module)= @_;
    $root=$module->root->gi();
}
