#!/bin/sh

TARGET=UTF-8

# First clean repository
# make cleaner

# Process files

for m in $(find modules/ -name "*.xml" -a ! -name ".*"; find entities/ manuals/*/* -name "*ent"; find manuals/ -name "master.top.xml");
do
  export MODNAME=`basename $m .xml`;
# ENCOD=$(head $m | grep '<?xml ')
  # Get only the 1st instance of "<?xml ", which must be the xml header itself
  ENCOD=$(grep '<?xml ' $m | head -1)
  if [ "$ENCOD" == "" ]; then 
      echo "ERROR!! I can't find an xml headerin $m, aborting... Please correct and start me again.";
      exit 1;
  fi
  ENCOD=$(echo $ENCOD | sed -e "s/.* encoding=[\'\"]//; s/[\'\"].*//")
  if [ "$ENCOD" == "" ]; then ENCOD="UTF-8"; fi
  if [ "$ENCOD" != "$TARGET" ]; then
      echo "Converting $m from $ENCOD to $TARGET...";
      perl -pi -e "s/( encoding=\")$ENCOD/\1$TARGET/" $m;
      iconv -f $ENCOD -t $TARGET --output $MODNAME.utf8 $m;
      mv $MODNAME.utf8 $m;
  fi
done